<?php
/**
 * elegantPURL Lite campaign UI
 *
 * PHP version 5
 *
 * @package   elegantPURL Lite
 * @author    Chris Lema (cflema@gmail.com) and Justin Kussow (jdkussow@gmail.com)
 * @copyright Copyright (c)2011 ALL RIGHTS RESERVED
 */
class epurl_campaign_ui {
    static $slug = "epurl_campaign";

    function add_metabox() {
        add_meta_box( 'epurl_campaign_div', 'ePurl Lite Campaign', array( 'epurl_campaign_ui', 'display_metabox_content' ), 'epurl_campaign', 'normal', 'high' );
    }

    function display_metabox_content() {
        global $post;

        $campaignId = $post->ID;

		$tab = 'settings';
        if ( array_key_exists( 'campaigntab', $_GET ) && $_GET['campaigntab'] ) $tab = $_GET['campaigntab'];

        $landing_page_id = get_post_meta( $campaignId, 'epurl_landing_page', true );
		$not_found_page_id = get_post_meta( $campaignId, 'epurl_not_found_page', true );

        $baseLPUrl = get_home_url() . '/' . $post->post_name . '/';

        $fields = get_post_meta( $campaignId, 'epurl_fields', true );

        // if fields is empty this is a new campaign, so let's add the default fields
        if ( !$fields ) {
            $fields = array();
            $fields[] = array( 'name' => 'first_name', 'display_name' => 'First Name', 'type' => 'text', 'is_builtin' => true, 'is_enabled' => true, 'can_disable' => false, 'is_required' => true);
            $fields[] = array( 'name' => 'last_name', 'display_name' => 'Last Name', 'type' => 'text', 'is_builtin' => true, 'is_enabled' => true, 'can_disable' => false, 'is_required' => true);
            $fields[] = array( 'name' => 'email', 'display_name' => 'Email', 'type' => 'text', 'is_builtin' => true, 'is_enabled' => true, 'can_disable' => true, 'is_required' => false);
            $fields[] = array( 'name' => 'postal_code', 'display_name' => 'Postal Code', 'type' => 'text', 'is_builtin' => true, 'is_enabled' => true, 'can_disable' => true, 'is_required' => false);
            $fields[] = array( 'name' => 'company_name', 'display_name' => 'Company Name', 'type' => 'text', 'is_builtin' => true, 'is_enabled' => true, 'can_disable' => true, 'is_required' => false);
        }

        // get members for this campaign
        $args = array( 'post_parent' => $campaignId, 'post_type' => 'epurl_member', 'post_status' => 'private', 'order'=> 'ASC', 'orderby' => 'title', 'numberposts' => -1 );
        $memberPosts = get_posts( $args );
         ?>
<section id="ep-campaign">
    <?php wp_nonce_field( plugin_basename(__FILE__), self::$slug . "_edit_nonce" ); ?>
    <input type="hidden" name="<?php echo self::$slug; ?>_check" value="1"/>
    <input type="hidden" id="_ep_campaign_id" value="<?php echo $campaignId; ?>" />
    <header>
        <p id="epc-error" class="epc-message">Error...should be hidden</p>
        <p id="epc-success" class="epc-message">Success...should be hidden</p>
        <nav class="epc-navigation">
            <ul class="epc-nav">
                <li class="epc-menu-item <?php echo ($tab == 'settings') ? 'epc-menu-item-active' : ''; ?>">
                    <a id="epc-settings" class="epc-menu-link">Settings</a>
                </li>
                <?php if ( in_array($post->post_status, array('private', 'publish') ) ) : ?>
                    <li class="epc-menu-item <?php echo ($tab == 'members') ? 'epc-menu-item-active' : ''; ?>">
                        <a id="epc-members" class="epc-menu-link">Members</a>
                    </li>
                <?php endif; ?>
            </ul>
        </nav>
    </header>
    <article class="epc-body">
        <div class="epcb-header"></div>
        <div id="epc-settings-div" class="epcb-content <?php echo ($tab == 'settings') ? 'epcb-content-active' : ''; ?>">
            <p>Here you can control which page is used for this campaign.</p>
            <ul id="epurl-dataform">
                <li>
                    <label for="ep_landing_page_id">Landing Page: </label>
                    <?php wp_dropdown_pages( array( 'name' => 'ep_landing_page_id', 'selected' => $landing_page_id ) ); ?>
                </li>
				<li>
                    <label for="ep_not_found_page_id">Not Found Page: </label>
					<?php wp_dropdown_pages( array( 'name' => 'ep_not_found_page_id', 'selected' => $not_found_page_id, 'show_option_none' => '- Select -' ) ); ?>
                </li>
            </ul>
        </div>
        <?php if ( in_array($post->post_status, array('private', 'publish') ) ) : ?>
        <div id="epc-members-div" class="epcb-content <?php echo ($tab == 'members') ? 'epcb-content-active' : ''; ?>">
            <p>Here you can manage who is part of the campaign.</p>
            <table id="epc-members-tbl" class="widefat epc-tbl">
                <thead>
                    <tr>
                        <th scope="col" style="display: none;">ID</th>
                        <th scope="col" style="display: none;">DATA</th>
                        <th scope="col">Name</th>
                        <th scope="col">Email</th>
                        <th scope="col">Landing Page</th>
                    </tr>
                    <tr>
                        <th colspan="3">
                            <a id="ep-new-member">Add</a> new member.
                        </th>
                    </tr>
                </thead>
                <tbody>
                    <?php
                    $alt = true;
                    foreach( $memberPosts as $post ) :
                        setup_postdata($post);
                        $memberId = $post->ID;
                        $landingPage = get_post_meta( $memberId, 'epurl_landing_page', true );
                        $memberData = array(
                            'id' => $memberId,
                            'landing_page' => $landingPage
                        );
                        $mFields = get_post_meta( $memberId, 'epurl_fields', true );
                        $fName = $mFields['first_name']['value'];
                        $lName = $mFields['last_name']['value'];

                        if ( $mFields['email'] )
                            $email = $mFields['email']['value'];

                        $memberData = array_merge( $memberData, $mFields );
                    ?>
                    <tr id="_ep_member_<?php echo $memberId; ?>" class="<?php echo ($alt) ? ' alternate' : ""; ?>">
                        <td style="display: none" id="_ep_member_<?php echo $memberId; ?>_id"><?php echo $memberId; ?></td>
                        <td style="display: none" id="_ep_member_<?php echo $memberId; ?>_data"><?php echo json_encode($memberData); ?></td>
                        <td><?php echo $fName . ' ' . $lName; ?></td>
                        <td><?php echo $email; ?></td>
                        <td><a class="_ep_member_link" href="<?php echo $baseLPUrl . $landingPage; ?>" target="_blank"><?php echo $baseLPUrl . $landingPage; ?></a></td>
                    </tr>
                    <?php $alt = !$alt; endforeach; ?>
                </tbody>
            </table>
        </div>
        <?php endif; ?>
    </article>
</section>
<div id="epurlMemberDetailsPopup" class="epurl-ui-dialog-content" title="PUT TITLE HERE">
    <div id="epmdPopupCore" class="epurl-ui-dialog-core">
        <div id="epmdPopupNotForm">
            <input type="hidden" id="junk" value="" />
            <input type="hidden" id="epmdSubmitAction" value="update" />
            <input type="hidden" id="_epmd_field_id" value="" />
            <input type="hidden" id="_epmd_field_landingpage_baseurl" value="<?php echo $baseLPUrl; ?>" />
            <?php foreach ( $fields as $f ) : $field = (object) $f; ?>
            <?php if ( !$field->is_enabled ) continue; ?>
            <div class="epmdrow epmdfieldrow" id="_epmd_field_<?php echo $field->name; ?>">
                <div class="epmdlabel"><label><?php echo $field->display_name; echo ($field->is_required) ? ' <em>*</em>' : ''; ?></label></div>
                <input type="text" id="_epmd_field_<?php echo $field->name; ?>_value" class="<?php echo ($field->is_required) ? ' required' : ''; ?>" value="" />
                <input type="hidden" id="_epmd_field_<?php echo $field->name; ?>_name" value="<?php echo $field->name; ?>" />
                <input type="hidden" id="_epmd_field_<?php echo $field->name; ?>_displayname" value="<?php echo $field->display_name; ?>" />
            </div>
            <?php endforeach; ?>
            <div class="epmdrow">
                <label>Landing Page </label>
                <a id="_epmd_field_landing_page" target="_blank"></a>
                <input type="hidden" id="_epmd_field_landing_page_value" value="" /><br />
                <span id="_epmd_field_landing_page_warning">The landing page is already taken for this campaign! Please change the member's first or last name.</span>
            </div>
        </div>
        <div class="fix"></div>
    </div>
    <div id="epmdPopupFooter">
        <div id="epmdFooterLeft">
            <button id="epmdDelete" class="button" style="display: none;">Delete</button>
        </div>
        <div id="epmdFooterRight">
            <button id="epmdSubmit" class="button-primary">Submit</button>
            <button id="epmdCancel" class="button">Cancel</button>
        </div>
        <div class="fix"></div>
    </div>
</div>
<script>
    epurl.init();
</script>
        <?php
    }

    function save_metabox_content( $post_id ) {
        if ( defined('DOING_AUTOSAVE') && DOING_AUTOSAVE )
            return;

        if ( defined('DOING_AJAX') && DOING_AJAX )
            return;

        if ( array_key_exists( 'post_type', $_POST ) && 
				( 'trash' == $_POST['post_type'] || 'auto-draft' == $_POST['post_type'] ) )
            return;

        if ( array_key_exists( 'post_type', $_POST ) && self::$slug != $_POST['post_type'] )
            return;

        if ( !current_user_can( 'edit_post', $post_id ) )
            return;

        if ( array_key_exists( self::$slug . '_edit_nonce', $_POST ) &&
				!wp_verify_nonce( $_POST[self::$slug . "_edit_nonce"], plugin_basename(__FILE__) ) )
            return;

        //OK, now we're authenticated; let's find and save the data
        if ( array_key_exists( self::$slug . '_check', $_POST ) && $_POST[self::$slug . '_check'] ) {
            update_post_meta( $post_id, 'epurl_landing_page', $_POST['ep_landing_page_id'] );
			update_post_meta( $post_id, 'epurl_not_found_page', $_POST['ep_not_found_page_id'] );
			
			$fields = array_key_exists( 'ep_fields', $_POST ) ? $_POST['ep_fields'] : null;
            update_post_meta( $post_id, 'epurl_fields', $fields );

            // rebuild the rewrite rules...
            elegantpurl::flush_rewrite_rules();
        }
    }
}
add_action( 'admin_menu', array( 'epurl_campaign_ui', 'add_metabox' ) ) ;
add_action( 'save_post', array( 'epurl_campaign_ui', 'save_metabox_content' ) );
?>
