<?php
/**
 * elegantPURL Lite shortcodes
 *
 * PHP version 5
 * 
 * @package   elegantPURL Lite
 * @author    Chris Lema (cflema@gmail.com) and Justin Kussow (jdkussow@gmail.com)
 * @copyright Copyright (c)2011 ALL RIGHTS RESERVED
 */
class epurl_shortcodes {
    function reload_all() {
        self::reload_directory( EPURL_DIR . 'shortcodes' ); // base shortcodes
    }
    
    function reload_directory( $dir ) {
        if ( strpos( strrev($dir), '/' ) !== 0 ) $dir .= '/';
        if ( !is_dir($dir) ) return; // directory does not exist        
        $files = scandir( $dir );
        foreach ( $files as $file ) {
            if ( $file === '.' || $file === '..' ) continue;
            if ( is_dir($dir . $file) ) {
                // campaign directory - load campaign custom shortcodes
                self::reload_directory( $dir . $file );
            } else {
                // only want files that start with "epurl-"
                if ( strpos( $file, 'epurl-') === 0 ) {
                    // only want files that end with ".php"
                    if ( strpos( strrev($file), strrev('.php') ) === 0 ) {
                        $path = $dir . $file;
                        include_once( $path );
                    }
                }
            }
        }
    }
}
?>
