/* 
 * elegantPURL Lite JS
 *
 * @package   elegantPURL Lite
 * @author    Chris Lema (cflema@gmail.com) and Justin Kussow (jdkussow@gmail.com)
 * @copyright Copyright (c)2011 ALL RIGHTS RESERVED
*/

if (typeof epurl == 'undefined') {
    epurl = {};
}

epurl = function() {
    var up;
    
    function switchCampaignTab() {
        jQuery('.epc-menu-item-active').removeClass('epc-menu-item-active');
        jQuery(this).parent().addClass('epc-menu-item-active');
        
        jQuery('.epcb-content-active').removeClass('epcb-content-active');
        jQuery('#' + jQuery(this).attr('id') + '-div').addClass('epcb-content-active');
    }
    
    function prepAddMember() {
        resetFields();
        
        jQuery('#ui-dialog-title-epurlMemberDetailsPopup').text('Add new member...');
        jQuery('#epmdSubmit').val('Add Member');
        jQuery('#epmdSubmitAction').val('create');
        jQuery('#epmdDelete').hide();
        
        updateLandingPageUrl();
        
        jQuery('#_epmd_field_first_name_value').bind("propertychange keyup input paste", updateLandingPageUrl);
        jQuery('#_epmd_field_last_name_value').bind("propertychange keyup input paste", updateLandingPageUrl);
        
        jQuery('#epurlMemberDetailsPopup').dialog('open');
        
        jQuery('#_epmd_field_first_name_value').focus();
    }
    
    function prepEditMember() {
        resetFields();
        
        var addedMissing = false;
        var thisId = jQuery(this).attr('id');
        var memberData = JSON.parse(jQuery('#' + thisId + '_data').text());
        
        jQuery('#ui-dialog-title-epurlMemberDetailsPopup').text('Update ' +  memberData['first_name']['value'] + ' ' + memberData['last_name']['value'] + '...');
        jQuery('#epmdSubmit').val('Update');
        jQuery('#epmdSubmitAction').val('update');                
        jQuery('#epmdDelete').show();
        
        updateLandingPageUrl(false);
        
        for (field in memberData) {
            if (field === 'id') {
                jQuery('#_epmd_field_' + field).val(memberData[field]);
            } else if (field === 'landing_page') {
                var url = jQuery('#_epmd_field_landingpage_baseurl').val() + memberData[field];                
                jQuery('#_epmd_field_landing_page').attr('href', url);
                jQuery('#_epmd_field_landing_page').text(url);
                jQuery('#_epmd_field_landing_page_value').val(memberData[field]);
            } else if (jQuery('#_epmd_field_' + field).length > 0) {       
                jQuery('#_epmd_field_' + field + '_value').val(memberData[field]['value']);
            } else {
                var html = '';
                
                if ( !addedMissing ) {
                    html += '<div id="epmdMissingFields">'
                }
                
                html += '<div class="epmdrow">';
                html += '<div class="epmdlabel"><label>' + memberData[field]['display_name'] + '</label></div>';
                html += '<input type="text" id="_epmd_field_' + field + '" class="_epmd_field" value="' + memberData[field]['value'] + '" />';
                html += '</div>';
                
                if ( !addedMissing ) {
                    html += '</div>'
                    jQuery('#epmdPopupNotForm div.epmdrow:last').before(html);
                } else {
                    jQuery('#epmcMissingFields div.epmdrow:last').after(html);
                }
            }
        }
        
        jQuery('#_epmd_field_first_name_value').unbind("propertychange keyup input paste", updateLandingPageUrl);
        jQuery('#_epmd_field_last_name_value').unbind("propertychange keyup input paste", updateLandingPageUrl);
        
        jQuery('#_epmd_field_first_name_value').attr('readonly', 'readonly');
        jQuery('#_epmd_field_last_name_value').attr('readonly', 'readonly');
        
        jQuery('#epurlMemberDetailsPopup').dialog('open');
    }
    
    function submitMemberDetailsForm() {
        if (!validateMemberNotForm())
            return false;
        
        var thisform = jQuery('#epmdPopupNotForm');
        
        var tblBody = jQuery('#epc-members-tbl > tbody');
        var memberId = -1;
        if (jQuery('#epmdSubmitAction').val() === 'update') {
            memberId = jQuery('#_epmd_field_id').val();
        }        
        
        // the first and last name fields will always be enabled and have these IDs
        var fullName = jQuery('#_epmd_field_first_name_value').val() + ' ' + 
            jQuery('#_epmd_field_last_name_value').val();
        
        var email = '';
        if ( jQuery('#_epmd_field_email_value').length > 0 )
            email = jQuery('#_epmd_field_email_value').val();
        
        var memberData = {
            id: memberId,
            campaign_id: jQuery('#_ep_campaign_id').val(),
            landing_page: jQuery('#_epmd_field_landing_page_value').val(),
            fields: { }
        };
        jQuery('#epmdPopupNotForm').children('.epmdrow.epmdfieldrow').each(function () {
            var field = jQuery(this).attr('id');
            memberData['fields'][jQuery('#' + field + '_name').val()] = {
                display_name: jQuery('#' + field + '_displayname').val(),
                value: jQuery('#' + field + '_value').val()
            };
        });
        
        var ajaxData = {
            action: 'epurl_savemember',
            security: epurl_params.login_nonce,
            memberData: memberData
        }
        
        jQuery.post(epurl_params.ajax_url, ajaxData, function(response) {
            if (response != '' && response != -1) {
                result = jQuery.parseJSON(response);
                if (result.success) {
                    var memberId = result.newData.id;
                    if (result.action === 'created') {
                        var url = jQuery('#_epmd_field_landingpage_baseurl').val() + result.newData.landing_page;
                        var html = '';
                        html += '<tr id="_ep_member_' + memberId + '">';
                        html += '<td style="display: none" id="_ep_member_' + memberId + '_id">' + memberId + '</td>';
                        html += '<td style="display: none" id="_ep_member_' + memberId + '_data">' + JSON.stringify(result.newData) + '</td>';
                        html += '<td>' + fullName + '</td>';
                        html += '<td>' + email + '</td>';
                        html += '<td><a href="' + url + '" target="_blank">' + url + '</a></td>';
                        html += '</tr>';
                        if (tblBody.children('tr:first-child').length > 0)
                            tblBody.children('tr:first-child').before(html);
                        else
                            tblBody.append(html);
                        jQuery('#epc-members-tbl > tbody tr').click(prepEditMember);
                        jQuery('._ep_member_link').click(ignoreClick);                        
                    } else {
                        jQuery('#_ep_member_' + memberId + '_data').text(JSON.stringify(result.newData));
                    }
                    refreshMemberHighlighting();
                    jQuery('#epurlMemberDetailsPopup').dialog('close');
                    jQuery('#_ep_member_' + memberId).delay(250).effect('highlight', {}, 3000);                    
                } else {
                    jQuery('#epmdPopupError').html(result.error);
                    jQuery('#epmdPopupError').fadeIn().delay(2000).fadeOut('normal', function() {
                        if (result.duplicateLP)
                            showLandingPageWarning();
                    });                    
                }
            }            
        });
        return false;
    }
    
    function deleteMember() {
        var thisform = jQuery('#epmdPopupNotForm');
        
        var memberId = jQuery('#_epmd_field_id').val();
        // the first and last name fields will always be enabled and have these IDs
        var fullName = jQuery('#_epmd_field_first_name_value').val() + ' ' + 
            jQuery('#_epmd_field_last_name_value').val();
        
        if ( !confirm('Are you sure you want to delete ' + fullName + '?') ) {
            return false;
        }
        
        var ajaxData = {
            action: 'epurl_deletemember',
            security: epurl_params.login_nonce,
            memberId: memberId
        }
        
        jQuery.post(epurl_params.ajax_url, ajaxData, function(response) {
            if (response != '' && response != -1) {
                result = jQuery.parseJSON(response);
                if (result.success) {
                    jQuery('#_ep_member_' + memberId).remove();
                    refreshMemberHighlighting();
                    jQuery('#epurlMemberDetailsPopup').dialog('close');
                } else {
                    jQuery('#epmdPopupError').html(result.error);
                    jQuery('#epmdPopupError').fadeIn().delay(2000).fadeOut('normal');
                }
            }            
        });
        return false;
    }
    
    function updateLandingPageUrl(validate) {
        var url = jQuery('#_epmd_field_landingpage_baseurl').val();
        var mUrl = escape(jQuery('#_epmd_field_first_name_value').val());
        mUrl += escape(jQuery('#_epmd_field_last_name_value').val());
        url += mUrl;
        
        jQuery('#_epmd_field_landing_page').attr('href', url);
        jQuery('#_epmd_field_landing_page').text(url);
        jQuery('#_epmd_field_landing_page_value').val(mUrl);

        if (validate === 'undefined' || validate) {
            // validate the url (make sure it is unique)
            validateLandingPage();
        }
    }
    
    function validateMemberNotForm() {
        var valid = true;
        jQuery('#epmdPopupNotForm input[type="text"]').each(function() {
            if (jQuery(this).hasClass("required") && !jQuery(this).val()) {
                jQuery(this).addClass("error");
                valid = false;
            }
        });
        return valid;
    }
    
    function validateMemberNotFormField() {
        if (jQuery(this).hasClass("required") && jQuery(this).val()) {
            jQuery(this).removeClass("error");
        }
    }
    
    function validateLandingPage() {
        var fName = jQuery('#_epmd_field_first_name_value').val();
        var lName = jQuery('#_epmd_field_last_name_value').val();
        
        if (!fName || !lName) {
            hideLandingPageWarning();
            return false;
        }
        
        var landingPage = escape(fName) + escape(lName);
        
        var ajaxData = {
            action: 'epurl_validatelandingpage',
            security: epurl_params.login_nonce,
            campaignId: jQuery('#_ep_campaign_id').val(),
            landingPage: landingPage            
        }
        
        jQuery.post(epurl_params.ajax_url, ajaxData, function(response) {
            if (response != '' && response != -1) {
                result = jQuery.parseJSON(response);
                if (result.success) 
                    hideLandingPageWarning();
                else
                    showLandingPageWarning();
            }            
        });
        return false;
    }
    
    function showLandingPageWarning() {
        jQuery('#_epmd_field_landing_page').addClass('error');
        jQuery('#_epmd_field_landing_page_warning').show();
    }
    
    function hideLandingPageWarning() {
        jQuery('#_epmd_field_landing_page').removeClass('error');
        jQuery('#_epmd_field_landing_page_warning').hide();        
    }
    
    function refreshMemberHighlighting() {
        var alt = true;
        jQuery("#epc-members-tbl > tbody tr").each(function() {
            if (alt)
                jQuery(this).addClass('alternate');
            else 
                jQuery(this).removeClass('alternate');
            alt = !alt;
        });        
        return false;
    }
    
    function resetFields() {
        jQuery('#_epmd_field_first_name_value').removeAttr('readonly');
        jQuery('#_epmd_field_last_name_value').removeAttr('readonly');
        if (jQuery('#epmdMissingFields').length > 0) { 
            jQuery('#epmdMissingFields').remove();
        }
        jQuery('#epmdPopupNotForm input[type="text"]').removeClass('error');
        jQuery('#epmdPopupNotForm input[type="text"]').val('');
        
        updateLandingPageUrl();
    }
    
    function ignoreClick(e) {
        e.stopPropagation();
    }
    
    return {
        init: function() {
            // borrowed from http://onwebdev.blogspot.com/2012/02/jquery-serialize-form-as-json-object.html
            jQuery.fn.serializeJSON = function() {
               var o = {};
               var a = this.serializeArray();
               jQuery.each(a, function() {
                   if (o[this.name]) {
                       if (!o[this.name].push) {
                           o[this.name] = [o[this.name]];
                       }
                       o[this.name].push(this.value || '');
                   } else {
                       o[this.name] = this.value || '';
                   }
               });
               return o;
            };
            
            // campaign tabs
            jQuery('.epc-menu-link').click(switchCampaignTab);
            
            // member actions
            jQuery('#epurlMemberDetailsPopup').dialog({
                autoOpen: false,
                modal: true,
                height: 490,
                width: 620,
				dialogClass: 'epurl-ui-dialog'                
            });
            jQuery('#epmdSubmit').click(submitMemberDetailsForm);
            jQuery('#epmdCancel').click(function() {
                jQuery('#epurlMemberDetailsPopup').dialog('close');
            });
            jQuery('#epmdDelete').click(deleteMember);
            jQuery('#ep-new-member').click(prepAddMember);
            jQuery('#epc-members-tbl > tbody tr').click(prepEditMember);
            jQuery('#epmdPopupNotForm input[type="text"]').blur(validateMemberNotFormField);            
            jQuery('._ep_member_link').click(ignoreClick);   
        }
    }
}();